import java.util.*;



public class seg {
	static final int INF = 2000000000;

	static class Stree {
		class Node {
			int val;
			int lb, rb;
			Node lch, rch;
		}
		
		Vector<Node> nodes;
		int n;
		
		public Stree(int nsize) {
			n = 1;
			while(n < nsize)
				n *= 2;
			
			nodes = new Vector<Node>(2*n);
			for(int i=0;i<2*n;i++) {
				nodes.add(new Node() );
				nodes.get(i).val = -INF;
			}
			
			for(int i=0;i<n;i++) {
				Node cur = nodes.get(n+i);
				cur.lb = i;
				cur.rb = i+1;
			}
			
			//Now create the tree structure
			//Leaves are the nodes n to 2*n-1
			//Exercise to reader: think why this approach constructs a perfect binary tree
			for(int i=n-1;i>0;i--) {
				Node cur = nodes.get(i);
				cur.lch = nodes.get(2*i);
				cur.rch = nodes.get(2*i+1);
				
				cur.lb = cur.lch.lb;
				cur.rb = cur.rch.rb;
			}
		}
		
		private void setDfs(int dest, int nval, Node cur) {
			if(cur.rb - cur.lb == 1) {
				cur.val = nval;
				return;
			}
			
			int mid = (cur.lb + cur.rb) / 2;
			if(dest < mid)
				setDfs(dest, nval, cur.lch);
			if(mid <= dest)
				setDfs(dest, nval, cur.rch);
			
			//Now update current node
			cur.val = Math.max(cur.lch.val, cur.rch.val);
		}
		
		public void set(int dest, int nval) {
			setDfs(dest, nval, nodes.get(1));
		}
		
		private int getDfs(int l, int r, Node cur) {
			if(l <= cur.lb && cur.rb <= r)
				return cur.val;
			
			int mid = (cur.lb + cur.rb) / 2;
			int result = -INF;
			
			if(l < mid)
				result = Math.max(result, getDfs(l, r, cur.lch) );
			if(mid < r)
				result = Math.max(result, getDfs(l, r, cur.rch) );
			return result;
		}
		
		public int get(int l, int r) {
			return getDfs(l, r, nodes.get(1));
		}
	}



	
	static public void main(String args[]) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt(), m = sc.nextInt();
		
		Stree stree = new Stree(n);
		
		for(int i=0;i<n;i++) {
			int val = sc.nextInt();
			stree.set(i, val);
		}
		
		for(int i=0;i<m;i++) {
			int type = sc.nextInt();
			
			if(type == 1) {
				int ind = sc.nextInt(), toAdd = sc.nextInt();
				int nval = stree.get(ind-1, ind) + toAdd;
				stree.set(ind-1, nval);
			}
			if(type == 2) {
				int ind = sc.nextInt(), nval = sc.nextInt();
				stree.set(ind-1, nval);
			}
			if(type == 3) {
				int l = sc.nextInt(), r = sc.nextInt();
				System.out.println(stree.get(l-1, r));
			}
		}
	}
}